// pingConverterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "pingConverter.h"
#include "pingConverterDlg.h"
#include <Wingdi.h>

	LOGFONT lf;	

	LOGFONT lf2;	
#include <map>
using namespace std;
#define NEW_ENTRY(STRYEM,STRALPHA) dictionary.insert(map<CString,CString>::value_type(STRYEM,STRALPHA))

class PingEncoder
{
public:
	map<CString,CString> dictionary;
	void init()
	{
	NEW_ENTRY("M1","M");
	NEW_ENTRY("M2","M0");
	NEW_ENTRY("M3","N");
	NEW_ENTRY("M4","N0");
	NEW_ENTRY("M5","N2");
	NEW_ENTRY("M6","N1");
	NEW_ENTRY("M7","O");
	NEW_ENTRY("M8","O0");
	NEW_ENTRY("M9","O1");
	

	NEW_ENTRY("L1","P");
	NEW_ENTRY("L2","P0");
	NEW_ENTRY("L3","Q");
	NEW_ENTRY("L4","Q0");
	NEW_ENTRY("L5","Q2");
	NEW_ENTRY("L6","Q1");
	NEW_ENTRY("L7","R");
	NEW_ENTRY("L8","R0");
	NEW_ENTRY("L9","R1");

	NEW_ENTRY("H1","S");
	NEW_ENTRY("H2","S0");
	NEW_ENTRY("H3","T");
	NEW_ENTRY("H4","T0");
	NEW_ENTRY("H5","T2");
	NEW_ENTRY("H6","T1");
	NEW_ENTRY("H7","U");
	NEW_ENTRY("H8","U0");
	NEW_ENTRY("H9","U1");

	NEW_ENTRY("Y1","V");
	NEW_ENTRY("Y2","V0");
	NEW_ENTRY("Y3","W");
	NEW_ENTRY("Y4","W0");
	NEW_ENTRY("Y5","W2");
	NEW_ENTRY("Y6","W1");
	NEW_ENTRY("Y7","X");
	NEW_ENTRY("Y8","X0");
	NEW_ENTRY("Y9","X1");

	NEW_ENTRY("K,1","a");
	NEW_ENTRY("K,2","a0");
	NEW_ENTRY("K,3","b");
	NEW_ENTRY("K,4","b0");
	NEW_ENTRY("K,5","b2");
	NEW_ENTRY("K,6","b1");
	NEW_ENTRY("K,7","c");
	NEW_ENTRY("K,8","c0");
	NEW_ENTRY("K,9","c1");

	NEW_ENTRY("J1","d");
	NEW_ENTRY("J2","d0");
	NEW_ENTRY("J3","e");
	NEW_ENTRY("J4","e0");
	NEW_ENTRY("J5","e2");
	NEW_ENTRY("J6","e1");
	NEW_ENTRY("J7","f");
	NEW_ENTRY("J8","f0");
	NEW_ENTRY("J9","f1");

	NEW_ENTRY("T1","g");
	NEW_ENTRY("T2","g0");
	NEW_ENTRY("T3","h");
	NEW_ENTRY("T4","h0");
	NEW_ENTRY("T5","h2");
	NEW_ENTRY("T6","h1");
	NEW_ENTRY("T7","i");
	NEW_ENTRY("T8","i0");
	NEW_ENTRY("T9","i1");

	NEW_ENTRY("P1","j");
	NEW_ENTRY("P2","j0");
	NEW_ENTRY("P3","k");
	NEW_ENTRY("P4","k0");
	NEW_ENTRY("P5","k2");
	NEW_ENTRY("P6","k1");
	NEW_ENTRY("P7","l");
	NEW_ENTRY("P8","l0");
	NEW_ENTRY("P9","l1");

	NEW_ENTRY("W1","m");
	NEW_ENTRY("W2","m0");
	NEW_ENTRY("W3","n");
	NEW_ENTRY("W4","n0");
	NEW_ENTRY("W5","n2");
	NEW_ENTRY("W6","n1");
	NEW_ENTRY("W7","o");
	NEW_ENTRY("W8","o0");
	NEW_ENTRY("W9","o1");

	NEW_ENTRY("S1","p");
	NEW_ENTRY("S2","p0");
	NEW_ENTRY("S3","q");
	NEW_ENTRY("S4","q0");
	NEW_ENTRY("S5","q2");
	NEW_ENTRY("S6","q1");
	NEW_ENTRY("S7","r");
	NEW_ENTRY("S8","r0");
	NEW_ENTRY("S9","r1");

	NEW_ENTRY("B1","s");
	NEW_ENTRY("B2","s0");
	NEW_ENTRY("B3","t");
	NEW_ENTRY("B4","t0");
	NEW_ENTRY("B5","t2");
	NEW_ENTRY("B6","t1");
	NEW_ENTRY("B7","u");
	NEW_ENTRY("B8","u0");
	NEW_ENTRY("B9","u1");

	NEW_ENTRY("N1","v");
	NEW_ENTRY("N2","v0");
	NEW_ENTRY("N3","w");
	NEW_ENTRY("N4","w0");
	NEW_ENTRY("N5","w2");
	NEW_ENTRY("N6","w1");
	NEW_ENTRY("N7","x");
	NEW_ENTRY("N8","x0");
	NEW_ENTRY("N9","x1");

	NEW_ENTRY("F1","y");
	NEW_ENTRY("F2","y0");
	NEW_ENTRY("F3","z");
	NEW_ENTRY("F4","z0");
	NEW_ENTRY("F5","z2");
	NEW_ENTRY("F6","z1");
	NEW_ENTRY("F7","A");
	NEW_ENTRY("F8","A0");
	NEW_ENTRY("F9","A1");

	NEW_ENTRY("CH1","B");
	NEW_ENTRY("CH2","B0");
	NEW_ENTRY("CH3",">");
	NEW_ENTRY("CH4",">0");
	NEW_ENTRY("CH5",">2");
	NEW_ENTRY("CH6",">1");
	NEW_ENTRY("CH7","C");
	NEW_ENTRY("CH8","C0");
	NEW_ENTRY("CH9","C1");

	NEW_ENTRY("G,1","E");
	NEW_ENTRY("G,2","E0");
	NEW_ENTRY("G,3","F");
	NEW_ENTRY("G,4","F0");
	NEW_ENTRY("G,5","F2");
	NEW_ENTRY("G,6","F1");
	NEW_ENTRY("G,7","G");
	NEW_ENTRY("G,8","G0");
	NEW_ENTRY("G,9","G1");

	NEW_ENTRY("KU1","H");
	NEW_ENTRY("KU2","H0");
	NEW_ENTRY("KU3","I");
	NEW_ENTRY("KU4","I0");
	NEW_ENTRY("KU5","I2");
	NEW_ENTRY("KU6","I1");
	NEW_ENTRY("KU7","J");
	NEW_ENTRY("KU8","J0");
	NEW_ENTRY("KU9","J1");

	NEW_ENTRY("V0","K");

	NEW_ENTRY("SH1","L");
	NEW_ENTRY("SH2","L0");
	NEW_ENTRY("SH3","3");
	NEW_ENTRY("SH4","30");
	NEW_ENTRY("SH5","32");
	NEW_ENTRY("SH6","31");
	NEW_ENTRY("SH7","4");
	NEW_ENTRY("SH8","40");
	NEW_ENTRY("SH9","41");

	NEW_ENTRY("NG1","8");
	NEW_ENTRY("NG2","80");
	NEW_ENTRY("NG3","9");
	NEW_ENTRY("NG4","90");
	NEW_ENTRY("NG5","92");
	NEW_ENTRY("NG6","91");
	NEW_ENTRY("NG7",":");
	NEW_ENTRY("NG8",":0");
	NEW_ENTRY("NG9",":1");

	NEW_ENTRY("D1","5");
	NEW_ENTRY("D2","50");
	NEW_ENTRY("D3","51");
	NEW_ENTRY("D4","52");
	NEW_ENTRY("D5","6");
	NEW_ENTRY("D6","60");
	NEW_ENTRY("D7","61");
	NEW_ENTRY("D8","62");
	NEW_ENTRY("D9","7");

	NEW_ENTRY("GU1",";");
	NEW_ENTRY("GU2",";0");
	NEW_ENTRY("GU3","<");
	NEW_ENTRY("GU4","<0");
	NEW_ENTRY("GU5","<2");
	NEW_ENTRY("GU6","<1");
	NEW_ENTRY("GU7","=");
	NEW_ENTRY("GU8","=0");
	NEW_ENTRY("GU9","=1");



	NEW_ENTRY("_","D");
	NEW_ENTRY("_1","D");
	NEW_ENTRY("_2","D0");
	NEW_ENTRY("_3","D2");
	NEW_ENTRY("_4","D1");
	NEW_ENTRY("_5","P2");
	NEW_ENTRY("_6","P1");
	NEW_ENTRY("_7","S2");
	NEW_ENTRY("_8","S1");
	NEW_ENTRY("_9","V2");

	NEW_ENTRY("UUD","M");
	NEW_ENTRY("EN","M0");

	NEW_ENTRY("U","P");
	NEW_ENTRY("ANG","P0");

	NEW_ENTRY("AD","S");
	NEW_ENTRY("UU","S0");

	NEW_ENTRY("ON","V");
	NEW_ENTRY("AB","V0");

	NEW_ENTRY("ID","a");
	NEW_ENTRY("OI","a0");

	NEW_ENTRY("IG","c");


	NEW_ENTRY("I","d");
	NEW_ENTRY("ING","d0");

	NEW_ENTRY("E","g");
	NEW_ENTRY("EI","g0");

	NEW_ENTRY("A","j");
	NEW_ENTRY("O","j0");
//
	NEW_ENTRY("OG","m");
	NEW_ENTRY("OU","m0");

	NEW_ENTRY("^ED","p");
	NEW_ENTRY("ONG","p0");

	NEW_ENTRY("EG","s");
	NEW_ENTRY("EB","s0");

	NEW_ENTRY("AN","u");
	NEW_ENTRY("AM","u0");

	NEW_ENTRY("UG","v");
	NEW_ENTRY("UN","v0");

	NEW_ENTRY("ED","y");
	NEW_ENTRY("EM","y0");

	NEW_ENTRY("UD","B");
	NEW_ENTRY("/E","B0");

	NEW_ENTRY("OD","E");
	NEW_ENTRY("OM","E0");

	NEW_ENTRY("AI","H");
	NEW_ENTRY("/EG","H0");

	NEW_ENTRY("UNG","K");
	NEW_ENTRY("/ENG","K0");

	NEW_ENTRY("UUN","L");
	NEW_ENTRY("EO","L0");

	NEW_ENTRY("^EN","8");
	NEW_ENTRY("^ENG","80");

	NEW_ENTRY("UI",";");
	NEW_ENTRY("IU",";0");

	NEW_ENTRY("AO","j2");
	NEW_ENTRY("AG","v2");
	NEW_ENTRY("IN","B2");
	NEW_ENTRY("^E","E2");
	NEW_ENTRY("^EU","H2");
	NEW_ENTRY("/EI","K2");
	NEW_ENTRY("ENG","82");


	}
	CString Encode(CString str)
	{
	str.TrimLeft();
	str.TrimRight();
	if(!isdigit(str[str.GetLength()-1])) return "error";
	CString whichsound=str.Mid(str.GetLength()-1);
	str.Delete(str.GetLength()-1);
	CString soundmother,soundson;
	bool doublesoundmother=false;
	if(str.Mid(0,2)=="KU")
		doublesoundmother=true;
	else if(str.Mid(0,2)=="G,")
	doublesoundmother=true;
	else if(str.Mid(0,2)=="K,")
	doublesoundmother=true;
	else if(str.Mid(0,2)=="GU")
	doublesoundmother=true;
	else if(str.Mid(0,2)=="SH")
	doublesoundmother=true;
	else if(str.Mid(0,2)=="CH")
	doublesoundmother=true;
	else if(str.Mid(0,2)=="NG")
	doublesoundmother=true;
	
	if(doublesoundmother)
	{
	soundmother=str.Mid(0,2);
	str.Delete(0,2);

	}

	else
	{
	soundmother=str.Mid(0,1);
	str.Delete(0);
	}
	soundmother+=whichsound;
	soundson=str;
	CString result;
	map<CString,CString>::iterator i;
	i=dictionary.find(soundmother);
	if(i!=dictionary.end()) result=(*i).second;
	else{return "error";}
	i=dictionary.find(soundson);
	if(i!=dictionary.end()) result+=(*i).second;
	else{return "error";}
	return result;
	}
};
PingEncoder pingenc;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnGoNet();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnGoNet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPingConverterDlg dialog

CPingConverterDlg::CPingConverterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPingConverterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPingConverterDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPingConverterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPingConverterDlg)
	DDX_Control(pDX, IDC_EDIT1, m_status);
	DDX_Control(pDX, IDC_SLIDER1, m_sld);
	DDX_Control(pDX, IDC_EDIT3, m_red2);
	DDX_Control(pDX, IDC_EDIT2, m_ed);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPingConverterDlg, CDialog)
	//{{AFX_MSG_MAP(CPingConverterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_EDIT2, OnChangeEdit2)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER1, OnReleasedcaptureSlider1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON1, OnAbout)
	ON_BN_CLICKED(IDC_BUTTON3, OnHelpOnline)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
	CFont cf;
/////////////////////////////////////////////////////////////////////////////
// CPingConverterDlg message handlers
#include <fstream>
void outmsg(CString &s,CString name_Var,CString i)
{
CString str;
str.Format("strcpy(%s,\"%s\");",name_Var,i);
s+=str;
}

void outmsg(CString &s,CString name_Var,int i)
{
CString str;
str.Format("%s=%d;",name_Var,i);
s+=str;
}
#define out_msg(name) outmsg(fonter,#name,name);
BOOL CPingConverterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
pingenc.init();
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	//this->ShowWindow(SW_MAXIMIZE);
	// TODO: Add extra initialization here
//	m_red.SetEventMask(ENM_CHANGE);
		
				
	//	CFont *s;
	//	s=this->GetFont();

		fstream fs;


	//	s->GetLogFont(&lf);
	//	fs.open("c:\\a.jjj.fnt.dat",ios::out|ios::binary);
	//	fs.write((char*)(void*)&lf,sizeof(LOGFONT));
	//	fs.close();	
	//	CString cmd=::GetCommandLine();
	//	cmd.TrimLeft();
	//	cmd.TrimRight();
	//	if(cmd[0]=='"');
	//	cmd.Delete(0);

	//	if(cmd[cmd.GetLength()-1]=='"');
	//	cmd.Delete(cmd.GetLength()-1);

	//	MessageBox(cmd+".a.fnt.dat");	
	//	fs.open(cmd+".a.fnt.dat",ios::in|ios::binary);	
	//	fs.read((char*)(void*)&lf,sizeof(LOGFONT));
		
		lf.lfCharSet=2;lf.lfClipPrecision=0;lf.lfEscapement=0;strcpy(lf.lfFaceName,"Pingyemhonyu");lf.lfHeight=-19;lf.lfItalic=0;lf.lfOrientation=0;lf.lfOutPrecision=0;lf.lfPitchAndFamily=2;lf.lfQuality=4;lf.lfStrikeOut=0;lf.lfUnderline=0;lf.lfWeight=400;lf.lfWidth=0;	
		
		lf.lfWidth=double(lf.lfWidth)*1.2;
		lf.lfHeight=double(lf.lfHeight)*1.2;
		lf.lfQuality=  ANTIALIASED_QUALITY;
		

	//	fs.close();	
		lf2=lf;
		cf.CreateFontIndirect(&lf2);
		


		m_red2.SetFont(&cf,TRUE);
		//LOGFONT test;

		m_sld.SetRange(0,100,TRUE);
		m_sld.SetPos(10);



	/*	CString fonter;
	
		out_msg(lf.lfCharSet);
		out_msg(lf.lfClipPrecision);
		out_msg(lf.lfEscapement);
		out_msg(lf.lfFaceName);
		out_msg(lf.lfHeight);
		out_msg(lf.lfItalic);
		out_msg(lf.lfOrientation);
		out_msg(lf.lfOutPrecision);
		out_msg(lf.lfPitchAndFamily);
		out_msg(lf.lfQuality);
		out_msg(lf.lfStrikeOut);
		out_msg(lf.lfUnderline);
		out_msg(lf.lfWeight);
		out_msg(lf.lfWidth);
m_status
		m_ed.SetWindowText(fonter);*/
		//AfxMessageBox(lf.lfFaceName);
	// with the ENM_CHANGE flag ORed into the mask.
	// with the ENM_CHANGE flag ORed into the mask.
		m_status.SetWindowText("Make sure that you got Pingyemhonyu font installed.Ready...");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPingConverterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPingConverterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPingConverterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}





void CPingConverterDlg::OnChangeEdit2() 
{
	
	CString str,res,str2;
	m_ed.GetWindowText(str);
	if(str==" ")
	{
		m_red2.SetSel(m_red2.GetWindowTextLength()+100,m_red2.GetWindowTextLength()+100);
		m_red2.ReplaceSel(" ",TRUE);
		m_ed.SetWindowText("");
		return;
	}

	for(int n=0;n<str.GetLength();n++)
	{
		if(str[n]==' ')
		{
	
		
		res=pingenc.Encode(str);
		if(res=="error")
		{
	//	AfxMessageBox("Invalid PingCode!!!");
		m_status.SetWindowText("Invalid PingCode!");
		m_ed.SetWindowText("");			
		break;
		}
		else
		{
		m_status.SetWindowText("Ready...");
		m_red2.SetSel(m_red2.GetWindowTextLength()+100,m_red2.GetWindowTextLength()+100);
		m_red2.ReplaceSel(res,TRUE);
		m_ed.SetWindowText("");
		}
		break;
		}
	}
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}

void CPingConverterDlg::OnReleasedcaptureSlider1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
//	CString pos;
//	pos.Format("%d",m_sld.GetPos());
//	MessageBox(pos);
changeFontSize(m_sld.GetPos());
	*pResult = 0;
}

void CPingConverterDlg::CHANGEFONT()
{
	
}

void CPingConverterDlg::changeFontSize(int size)
{	
		lf2.lfWidth=double(lf.lfWidth)*size/10;
		lf2.lfHeight=double(lf.lfHeight)*size/10;

	
	//	CFont cf;

		cf.CreateFontIndirect(&lf2);
		
		m_red2.SetFont(&cf,TRUE);

}


void CPingConverterDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	m_red2.SetSel(0,m_red2.GetWindowTextLength());
	m_red2.Copy();
	m_red2.SetSel(0,0);
}

void CAboutDlg::OnGoNet() 
{
	// TODO: Add your control notification handler code here
	ShellExecute(NULL,"open","http://www.susis.ust.hk/~albertcw","","",SW_SHOW);
}

void CPingConverterDlg::OnAbout() 
{
	// TODO: Add your control notification handler code here
	CAboutDlg ca;
	ca.DoModal();
}

void CPingConverterDlg::OnHelpOnline() 
{
	// TODO: Add your control notification handler code here
	ShellExecute(NULL,"open","http://www.susis.ust.hk/~albertcw","","",SW_SHOW);	
}
